-------------------------------------------------------------------------------------------------
DisplayTrace( "(c)2004 Warlord George (Am Pass im Kaukasus V1.4)");
-------------------------------------------------------------------------------------------------

A_Move = 0;
A_Swarm = 3;
A_Stop = 9;
A_Para = 22;
A_GndAttack=36;
A_Fighters=20;
AviationState = {};

-- Mission gewonnen --
function Sieg()
	-- Wenn der Pass in unserer Hand ist dann Sieg
	if (GetNUnitsInArea (1, "PASS") <1) then
		ObjectiveChanged(5, 1);
		RunScript( "Ende", 5000);
		Suicide();
	end;
end;

function Niederlage()
	if ((GetIGlobalVar("Objective.1.BM13", 0) + GetIGlobalVar("Objective.2.Ari", 0) + GetIGlobalVar("Objective.3.Flak", 0) + GetIGlobalVar("Objective.4.Cargo", 0)) <4) then
		-- Mission verloren wenn Spher gefallen 
		if ((GetNUnitsInParty(0) - GetNUnitsInScriptGroup (111,0)) <1) then
			Loose();
			Suicide();
		end;
	else
		-- Auf zum letzten Ziel, nehmen wir den Pass
		KillScript("CheckMainMissions");
		KillScript("CheckSubMissions");
		ObjectiveChanged(5, 0);
		--
		SwitchWeather(0);       
		--SwitchWeatherAutomatic(1);
		RunScript( "GermanTruppen", 5000);
		RunScript( "Alarmzone", 2000);
		RunScript( "Niederlage1", 10000);
		--
		RunScript( "AirCtrl1", 2300);
		RunScript( "AirCtrl2", 2600);
		RunScript( "AirCtrl3", 2900);
		Suicide();
	end;
end;

function Niederlage1()
	-- Wir wurden beim Angriff aufgerieben
	if (GetNUnitsInParty(0) <10) then
		Loose();
		Suicide();
	end;
end;

function Ende()
	Win(0);
	Suicide();
end;
-------------------------------------------------------------------------------------------------

function GermanTruppen()
	AviationState = {0, "All", 0, "NoScout", 0, "NoBomber", 0, "NoPara"};
	SetAviation(4);
	LandReinforcement (20);
	Suicide();
end;

function GermanNachschub()
	LandReinforcement (30);
	Suicide();
end;

function Alarmzone()
	if (GetNScriptUnitsInArea (20, "ALARMZONE") > 0) then
		LandReinforcement (175);
		RunScript( "GermanNachschub", 120000);
		Suicide();
	end;
end;

function AirCtrl1()
	if ((GetNScriptUnitsInArea (20, "DORF") > 0) or (GetNScriptUnitsInArea (30, "DORF") > 0)) then
		AviationState = {1, "GndAttack"};
		SetAviation(1);
		Cmd(A_GndAttack, 1000, 1, GetScriptAreaParams("DORF"));
	end;
end;

function AirCtrl2()
	if (GetNScriptUnitsInArea (20, "PATROL1_2") > 0)  then
		AviationState = {1, "GndAttack"};
		SetAviation(1);
		Cmd(A_GndAttack, 1000, 1, GetScriptAreaParams("PATROL1_2"));
	end;
end;

function AirCtrl3()
	if (GetAviationState(0) == 4) then
		AviationState = {1, "Fighters"};
		SetAviation(1);
		Cmd(A_Fighters, 1000, 1, GetScriptAreaParams("ALARMZONE"));
		Suicide();
	end;
end;
-------------------------------------------------------------------------------------------------
-- Ziel Dorf und Nachschub
function Objective0()
	ObjectiveChanged(0, 0);
	SetIGlobalVar("Objective.0.Dorf", 0);
	SetIGlobalVar("Objective.1.BM13", 0);
	SetIGlobalVar("Objective.2.Ari", 0);
	SetIGlobalVar("Objective.3.Flak", 0);
	SetIGlobalVar("Objective.4.Cargo", 0);
	ViewZone ("DORF", 1);
	Suicide();
end;

-- Ziel Raketenwerfer
function Objective1()
	ObjectiveChanged(1, 0);
	SetIGlobalVar("Objective.1.BM13", 0);
	ViewZone ("ZAUN1", 1);
	ViewZone ("ZAUN2", 1);
	RunScript( "ViewZaunAus", 10000);
	Suicide();
end;

-- Ziel Artillerie
function Objective2()
	ObjectiveChanged(2, 0);
	SetIGlobalVar("Objective.2.Ari", 0);
	Suicide();
end;

-- Ziel Flakstellungen
function Objective3()
	ObjectiveChanged(3, 0);
	SetIGlobalVar("Objective.3.Flak", 0);
	Suicide();
end;

-- Ziel Nachschubkolonne
function Objective4()
	ObjectiveChanged(4, 0);
	SetIGlobalVar("Objective.4.Cargo", 0);
	Suicide();
end;

-- Sekundaerziele in Grundstellung
function SubObjectives()
	LandReinforcement (193);			-- Nachschub fuer SU122
	SetIGlobalVar("Objective.Sub.Jeep", 0);
	SetIGlobalVar("Pioniere.Status", 0);
	SetIGlobalVar("Offizier.Status", 0);
	Suicide();
end;

function ViewZaunAus()
	ViewZone ("ZAUN1", 0);
	ViewZone ("ZAUN2", 0);
	SetIGlobalVar("Pioniere.Status", 1);
	Suicide();
end;
-------------------------------------------------------------------------------------------------

-- Spher absetzen --
function Spaeherkommt()
	ViewZone ("DORF", 0);
	SetIGlobalVar("german.para.id", 10);
	AviationState = {1, "NoAll", 0, "NoAll", 0,"Para"};
	SetAviation(3);
	SwitchWeatherAutomatic(0);
	SwitchWeather(0);
	DisplayTrace( "Achtung, unser Einzelkmpfer wird abgesetzt !");
	Cmd(A_Para, GetIGlobalVar("german.para.id", 0), 0, GetScriptAreaParams("LANDEZONE"));
	RunScript( "Spaeherkommt1", 2000);
	Suicide();
end;

function Spaeherkommt1()
	local x, y = GetObjCoord (GetIGlobalVar("german.para.id", 0));		-- warten bis Spaeher sicher abgesetzt
	if (x < 0) then
		SwitchWeather(1);							-- ab jetzt Schnee
		DisplayTrace( "Achtung, ein Sowjetischer Offizier in westlicher Richtung muss unsere Landung bemerkt haben !");
		Cmd (A_Move, 107, GetScriptAreaParams("LANDEZONE"));	-- USSR Offizier hat Landung bemerkt
		RunScript( "Niederlage",1000);
		RunScript( "CheckMainMissions",1500);
		RunScript( "CheckSubMissions",2000);
		Suicide();
	end;
end;
-------------------------------------------------------------------------------------------------

function CheckMainMissions()
	-- Check ob Dorf im NO in unserer Hand ist
	-- Patroullie 4 (USSR_Gunner) wird dabei nicht bercksichtigt
	-- Patroullie 6 (USSR_hmg) muss ausgeschaltet sein
	if (GetIGlobalVar("Objective.0.Dorf", 0) <1) then
		if ((GetNUnitsInScriptGroup (110,1) < 1) and (GetNUnitsInScriptGroup (106) < 1)) then
			ChangePlayer (111, 0);
			DisplayTrace( "Sehr gut, unser Munitionsnachschub ist gesichert !");
			SetIGlobalVar("Objective.0.Dorf", 1);
			ObjectiveChanged(0, 1);
			RunScript( "Objective1", 2000);
			RunScript( "Objective2", 4000);
			RunScript( "Objective3", 6000);
			RunScript( "Objective4", 8000);
		end;
	end;
	-----------------------
	-- Check ob Raketenwerfer vernichtet wurde
	if (GetIGlobalVar("Objective.1.BM13", 0) <1) then
		if (GetNUnitsInScriptGroup (120) < 1) then
			ObjectiveChanged(1, 1);
			SetIGlobalVar("Objective.1.BM13", 1);
			LandReinforcement (108);
		end;
	end;
	-----------------------
	-- Check ob Artillerie ausgeschaltet wurde
	if (GetIGlobalVar("Objective.2.Ari", 0) <1) then
		if (GetNUnitsInScriptGroup (130,1) < 1) then
			ObjectiveChanged(2, 1);
			SetIGlobalVar("Objective.2.Ari", 1);
			Cmd (A_Swarm, 182, 1059, 6707);
		end;
	end;
	-----------------------
	-- Check ob Flak ausgeschaltet wurde
	if (GetIGlobalVar("Objective.3.Flak", 0) <1) then
		if (GetNUnitsInScriptGroup (140,1) < 1) then
			ObjectiveChanged(3, 1);
			SetIGlobalVar("Objective.3.Flak", 1);
		end;
	end;
	-----------------------
	-- Check ob Nachschubkollone vernichtet wurde
	if (GetIGlobalVar("Objective.4.Cargo", 0) <1) then
		if (GetNUnitsInScriptGroup (150) < 1) then
			ObjectiveChanged(4, 1);
			SetIGlobalVar("Objective.4.Cargo", 1);
		end;
	end;
	-----------------------
end;
-------------------------------------------------------------------------------------------------

function CheckSubMissions()
	-- wenn Jeep auf Bruecke zerstoert ist, wird Patroullie aufmerksam
	if (GetIGlobalVar("Objective.Sub.Jeep", 0) <1) then
		if (GetNUnitsInScriptGroup (190) < 1) then
			SetIGlobalVar("Objective.Sub.Jeep", 1);
			local X_Ziel = 2000 + RandomInt (350);
			Cmd (A_Swarm, 191, 1652, 7189);
				QCmd (A_Swarm, 191, X_Ziel, 7189);
		end;
	end;
	-----------------------
	-- Reaktion wenn Offizier auf Brcke zuerst gettet wird
	if ((GetNUnitsInScriptGroup (180) < 1) and (GetNUnitsInScriptGroup (181) > 0)) then
		Cmd (A_Swarm, 181, 2720, 7213);
	end;
	-- Reaktion des Offiziers wenn Wachsoldaten auf Brcke vor ihm gettet werden
	if (((GetNUnitsInScriptGroup (180) >0) and (GetNUnitsInScriptGroup (181) < 1)) and (GetIGlobalVar("Offizier.Status", 0) == 0)) then
		Cmd (A_Move, 180, GetScriptAreaParams("BRUECKE"));
		SetIGlobalVar("Offizier.Status", 1);
	end;
	-- wenn Offizier Alarmzone auf Brcke erreicht wird ein Suchtrupp losgeschickt
	if (GetNScriptUnitsInArea (180, "BRUECKE") > 0) then
		Cmd (A_Swarm, 180, 1402, 6954);
		Cmd (A_Swarm, 179, GetScriptAreaParams("PATROL3_1"));
			QCmd (A_Swarm, 179, GetScriptAreaParams("ZAUN_2"));
			QCmd (A_Swarm, 179, GetScriptAreaParams("BRUECKE"));
			QCmd (A_Swarm, 179, GetScriptAreaParams("PATROL3_2"));
	end;
	-----------------------
	-- Pioniere am Zaun 
	if ((GetIGlobalVar("Pioniere.Status", 0) >0) and (GetIGlobalVar("Pioniere.Status", 0) <3)) then
		local num = GetIGlobalVar("Pioniere.Status", 0) +1
		if (GetNUnitsInScriptGroup (109,1) < 1) then
			LandReinforcement (109);			
			SetIGlobalVar("Pioniere.Status", num);
		end;
		if (GetNUnitsInScriptGroup (189,1) < 1) then
			LandReinforcement (189);
			SetIGlobalVar("Pioniere.Status", num);
		end;
	end;
end;
-------------------------------------------------------------------------------------------------

--Patroullie 1 T-70 im Wald westlich
function Patrol1()
	if (GetNUnitsInScriptGroup (101) > 0) then
		if (GetNScriptUnitsInArea (101, "PATROL1_1") > 0) then
			Cmd (A_Swarm, 101, GetScriptAreaParams("PATROL1_2"));
		end;
		if (GetNScriptUnitsInArea (101, "PATROL1_2") > 0) then
			Cmd (A_Swarm, 101, GetScriptAreaParams("PATROL1_1"));
		end;
	else
		Suicide();
	end;	
end;

--Patroullie 2 T-70 bei Pass
function Patrol2()
	if (GetNUnitsInScriptGroup (102) > 0) then
		if (GetNScriptUnitsInArea (102, "PATROL2_1") > 0) then
			Cmd (A_Swarm, 102, GetScriptAreaParams("PATROL2_2"));
		end;
		if (GetNScriptUnitsInArea (102, "PATROL2_2") > 0) then
			Cmd (A_Swarm, 102, GetScriptAreaParams("PATROL2_1"));
		end;
	else
		Suicide();
	end;	
end;

--Patroullie 3 bei BM13
function Patrol3()
	if (GetNUnitsInScriptGroup (103) > 0) then
		if (GetNScriptUnitsInArea (103, "PATROL3_1") > 0) then
			Cmd (A_Swarm, 103, GetScriptAreaParams("PATROL3_2"));
		end;
		if (GetNScriptUnitsInArea (103, "PATROL3_2") > 0) then
			Cmd (A_Swarm, 103, GetScriptAreaParams("PATROL3_1"));
		end;
	else
		RunScript( "PatrolMsg", 500);
		Suicide();
	end;	
end;

--Patroullie 4 beim Dorf NO
function Patrol4()
	if (GetNUnitsInScriptGroup (104) > 0) then
		if (GetNScriptUnitsInArea (104, "PATROL4_1") > 0) then
			Cmd (A_Swarm, 104, GetScriptAreaParams("PATROL4_2"));
		end;
		if (GetNScriptUnitsInArea (104, "PATROL4_2") > 0) then
			Cmd (A_Swarm, 104, GetScriptAreaParams("PATROL4_1"));
		end;
	else
		RunScript( "PatrolMsg", 500);
		Suicide();
	end;	
end;

--Patroullie 5 im Wald von S nach N
function Patrol5()
	local P_Ziel = RandomInt (3);
	if (GetNUnitsInScriptGroup (105) > 0) then
		if (GetNScriptUnitsInArea (105, "PATROL5_1") > 0) then
			if (P_Ziel == 0) then
				Cmd (A_Swarm, 105, GetScriptAreaParams("PATROL5_2"));
			end;
			if (P_Ziel == 1) then
				Cmd (A_Swarm, 105, GetScriptAreaParams("PATROL5_3"));
			end;
			if (P_Ziel == 2) then
				Cmd (A_Swarm, 105, GetScriptAreaParams("PATROL5_4"));
			end;
		end;
		if ((GetNScriptUnitsInArea (105, "PATROL5_2") + GetNScriptUnitsInArea (105, "PATROL5_3") + GetNScriptUnitsInArea (105, "PATROL5_4")) > 0) then
			Cmd (A_Swarm, 105, GetScriptAreaParams("PATROL5_1"));
		end;
	else
		RunScript( "PatrolMsg", 500);
		Suicide();
	end;	
end;

--Patroullie 6 im Dorf NO
function Patrol6()
	if (GetNUnitsInScriptGroup (106) > 0) then
		if (GetNScriptUnitsInArea (106, "PATROL6_1") > 0) then
			Cmd (A_Swarm, 106, GetScriptAreaParams("PATROL6_2"));
		end;
		if (GetNScriptUnitsInArea (106, "PATROL6_2") > 0) then
			Cmd (A_Swarm, 106, GetScriptAreaParams("PATROL6_1"));
		end;
	else
		RunScript( "PatrolMsg", 500);
		Suicide();
	end;	
end;

--Bwegung Nachschub SU122
function NS_SU122()
	local tmpDelay = 30000 + RandomInt (60000);
	if (GetNUnitsInScriptGroup (193) > 0) then
		if (GetNScriptUnitsInArea (193, "NS_SU122") > 0) then
			RunScript( "MOVE_NS_SU122", tmpDelay);
			Suicide();
		end;
		if (GetNScriptUnitsInArea (193, "EXIT") > 0) then
			DeleteReinforcement (193);
			LandReinforcement (193);
		end;
	else
		-- wenn Cargo bei SU122 Batterie zerstoert ist, wird Ari Einsatz blockiert
		ChangePlayer (192, 2);
		Suicide();
	end;	
end;

function MOVE_NS_SU122()
	if (GetNUnitsInScriptGroup (193) > 0) then
		if (GetNScriptUnitsInArea (193, "NS_SU122") > 0) then
			Cmd (A_Move, 193, 2816, 5620);
				QCmd (A_Move, 193, 2968, 4143);
				QCmd (A_Move, 193, 941, 4185);
				QCmd (A_Move, 193, GetScriptAreaParams("EXIT"));
			RunScript( "NS_SU122", 10000);
			Suicide();
		end;
	else
		-- wenn Cargo bei SU122 Batterie zerstoert ist, wird Ari Einsatz blockiert
		ChangePlayer (192, 2);
		Suicide();
	end;	
end;

function PatrolMsg()
	DisplayTrace( "Jawohl, und wieder ein Problem weniger !");
	Suicide();
end;
-------------------------------------------------------------------------------------------------

function SetAviation(iStatis)
	for i = 1, iStatis*2, 2 do			-- Schleife ueber Tabelle
		if (AviationState[i+1] == "NoScout") then        -- Aufklaerung
			DisableAviation (AviationState[i] , 0);			
		elseif (AviationState[i+1] == "Scout") then
			EnableAviation (AviationState[i] , 0);			
		elseif (AviationState[i+1] == "NoFighters") then    -- Fighters
			DisableAviation (AviationState[i] , 1);			
		elseif (AviationState[i+1] == "Fighters") then
			EnableAviation (AviationState[i] , 1);			
		elseif (AviationState[i+1] == "NoPara") then    -- Luftlande
			DisableAviation (AviationState[i] , 2);			
		elseif (AviationState[i+1] == "Para") then
			EnableAviation (AviationState[i] , 2);			
		elseif (AviationState[i+1] == "NoBomber") then    -- Bomber
			DisableAviation (AviationState[i] , 3);			
		elseif (AviationState[i+1] == "Bomber") then
			EnableAviation (AviationState[i] , 3);			
		elseif (AviationState[i+1] == "NoGndAttack") then    -- Bodenkampf
			DisableAviation (AviationState[i] , 4);			
		elseif (AviationState[i+1] == "GndAttack") then
			EnableAviation (AviationState[i] , 4);			
		elseif (AviationState[i+1] == "NoAll") then           -- ALLE
			DisableAviation (AviationState[i] , -1);			
		elseif (AviationState[i+1] == "All") then
			EnableAviation (AviationState[i] , -1);			
		end;
	end;
end; 
-------------------------------------------------------------------------------------------------

-- Mission Initialisierung
function Init()
	RunScript( "Objective0", 1000);
	RunScript( "SubObjectives", 2000);
	RunScript( "Sieg",3000);
	RunScript( "Spaeherkommt",12000);
	RunScript( "Patrol1", 5000);
	RunScript( "Patrol2", 5100);
	RunScript( "Patrol3", 5200);
	RunScript( "Patrol4", 5300);
	RunScript( "Patrol5", 5400);
	RunScript( "Patrol6", 5500);
	RunScript( "NS_SU122", 5600);
end;